<?php
/**
 * @package payanyway payment module
 *
 * @package paymentMethod
 * @copyright Copyright 2003-2010 Zen Cart Development Team
 * @copyright Portions Copyright 2003 osCommerce
 * @license http://www.zen-cart.com/license/2_0.txt GNU Public License V2.0
 * @version $Id: payanyway.php 15420 2010-02-04 21:27:05Z drbyte $
 */

	class payanyway {
		var $code, $title, $description, $enabled;
		var $params = array('unit_id' => '', 'limit_ids' => '', 'account_id' => '', 'online' => 1);

		// class constructor
		function payanyway() {
			global $order;

			$this->code = 'payanyway';
			$this->title = MODULE_PAYMENT_PAYANYWAY_TEXT_TITLE;
			$this->description = MODULE_PAYMENT_PAYANYWAY_TEXT_DESCRIPTION;
			$this->sort_order = MODULE_PAYMENT_PAYANYWAY_SORT_ORDER;
			$this->enabled =	((MODULE_PAYMENT_PAYANYWAY_STATUS == 'True') ? true : false);

			if ((int)MODULE_PAYMENT_PAYANYWAY_PREPARE_ORDER_STATUS_ID > 0) {
				$this->order_status = MODULE_PAYMENT_PAYANYWAY_PREPARE_ORDER_STATUS_ID;
			}

			if (is_object($order)) $this->update_status();
		}

		// class methods
		function update_status() {
			global $order, $db;

			if ( ($this->enabled == true) && ((int)MODULE_PAYMENT_PAYANYWAY_ZONE > 0) ) {
				$check_flag = false;
				$check_query = $db->Execute("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_PAYMENT_PAYANYWAY_ZONE . "' and zone_country_id = '" . $order->billing['country']['id'] . "' order by zone_id");
				while ($check = $check_query->fields) {
					if ($check['zone_id'] < 1) {
						$check_flag = true;
						break;
					} elseif ($check['zone_id'] == $order->billing['zone_id']) {
						$check_flag = true;
						break;
					}
				}

				if ($check_flag == false) {
					$this->enabled = false;
				}
			}
		}

		function javascript_validation() {
			return false;
		}
		
		function selection() {
			return array('id' => $this->code, 'module' => $this->title);
		}

		function pre_confirmation_check() {
			return false;
		}

		function confirmation() {
			return false;
		}

		function process_button() {
			return false;
		}

		function before_process() {
			return false;
		}

		function after_process() {
			global $insert_id, $currencies, $order, $db, $cart;
			
			switch (MODULE_PAYMENT_PAYANYWAY_TEST_MODE) {
				case 'Real':
					$test_mode = '0';
					break;
				case 'Test':
					$test_mode = '1';
					break;
			}
			
			$lang_query = $db->Execute("select code from " . TABLE_LANGUAGES . " where languages_id = '" . (int)$languages_id . "'");
			$lang = $lang_query->fields; 
			
			switch (strtolower($lang['code'])) {
				case 'en':
				case 'ru':
					$language_code = strtolower($lang['code']);
					break;
				default:
					$language_code = strtolower(DEFAULT_LANGUAGE);
			}
			
//			$transactionId = STORE_NAME . date('Ymdhis') . rand (0, 99999);
			$amount = number_format($order->info['total'] * $currencies->get_value(MODULE_PAYMENT_PAYANYWAY_CURRENCY_CODE), 2, '.', '');
			
			$order_id = $insert_id;
			$currency = ('RUR' == MODULE_PAYMENT_PAYANYWAY_CURRENCY_CODE) ? 'RUB' : MODULE_PAYMENT_PAYANYWAY_CURRENCY_CODE;
			if ($this->params['online']) {
				$action = 'https://' . MODULE_PAYMENT_PAYANYWAY_SERVER . '/assistant.htm?';
			} else {
				$action = zen_href_link('payanyway_invoice');
			}
			
			$_SESSION['cart']->reset(true);
			unset($_SESSION['sendto']);
			unset($_SESSION['billto']);
			unset($_SESSION['shipping']);
			unset($_SESSION['payment']);
			unset($_SESSION['comments']);
			zen_redirect( $action .
								'&MNT_ID=' . MODULE_PAYMENT_PAYANYWAY_MERCHANT_ID .
								'&MNT_TRANSACTION_ID=' . $order_id . 
								'&MNT_AMOUNT=' . $amount .
								'&MNT_CURRENCY_CODE=' . $currency .
								'&MNT_TEST_MODE=' . $test_mode .
								'&MNT_SIGNATURE=' . md5(MODULE_PAYMENT_PAYANYWAY_MERCHANT_ID . $order_id . $amount . $currency . $test_mode . MODULE_PAYMENT_PAYANYWAY_DATA_INTEGRITY_CODE) .
								'&MNT_SUCCESS_URL=' . zen_href_link(FILENAME_CHECKOUT_SUCCESS, '', 'SSL') .
								'&MNT_FAIL_URL=' . zen_href_link(FILENAME_CHECKOUT_PAYMENT, '', 'SSL') .
								'&paymentSystem.unitId=' . $this->params['unit_id'] .
								'&paymentSystem.limitIds=' . $this->params['limit_ids'] .
								'&paymentSystem.accountId=' . $this->params['account_id'] .
								'&payment_system=' . $this->code .
								'&followup=true' .
								'&javascriptEnabled=true' .
								'&orderId=' . $order_id .
								'&customerId=' . $customer_id .
								'&moneta.locale=' . $language_code);
		}
		
		function output_error() {
			return false;
		}

		function check() {
			global $db;

			if (!isset($this->_check)) {
				$check_query = $db->Execute("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_PAYANYWAY_STATUS'");
				$this->_check = $check_query->RecordCount();
			}
			return $this->_check;
		}

		function install() {
			global $db;

			$check_query = $db->Execute("select orders_status_id from " . TABLE_ORDERS_STATUS . " where orders_status_name = 'Preparing [PayAnyWay]' limit 1");

			if ($check_query->RecordCount() < 1) {
				$status_query = $db->Execute("select max(orders_status_id) as status_id from " . TABLE_ORDERS_STATUS);
				$status = $status_query->fields;

				$status_id = $status['status_id']+1;

				$languages = zen_get_languages();

				for ($i=0, $n=sizeof($languages); $i<$n; $i++) {
					$db->Execute("insert into " . TABLE_ORDERS_STATUS . " (orders_status_id, language_id, orders_status_name) values ('" . $status_id . "', '" . $languages[$i]['id'] . "', 'Preparing [PayAnyWay]')");
				}

				$flags_query = $db->Execute("describe " . TABLE_ORDERS_STATUS . " public_flag");
				if ($flags_query->RecordCount() == 1) {
					$db->Execute("update " . TABLE_ORDERS_STATUS . " set public_flag = 1 and downloads_flag = 0 where orders_status_id = '" . $status_id . "'");
				}
			} else {
				$check = $check_query->fields;

				$status_id = $check['orders_status_id'];
			} 
		
			$db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable PayAnyWay Module', 'MODULE_PAYMENT_PAYANYWAY_STATUS', 'True', 'Do you want to accept PayAnyWay payments?', '6', '1', 'zen_cfg_select_option(array(\'True\', \'False\'), ', now())");
			$db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Payment Server', 'MODULE_PAYMENT_PAYANYWAY_SERVER', 'www.payanyway.ru', 'URL of Payment System', '6', '2', now())");
			$db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Merchant ID', 'MODULE_PAYMENT_PAYANYWAY_MERCHANT_ID', '', 'Merchant ID in PayAnyWay system. Corresponds to advanced account number of the merchant', '6', '3', now())");
			$db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Transaction Currency Code', 'MODULE_PAYMENT_PAYANYWAY_CURRENCY_CODE', 'RUR', 'ISO currency code which is used for payment of the order. The currency code must correspond to the currency of the recipient account (Merchant ID)', '6', '4', 'zen_cfg_select_option(array(\'RUR\', \'EUR\', \'USD\', \'GBP\'), ', now())");
			$db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Data Integrity Code', 'MODULE_PAYMENT_PAYANYWAY_DATA_INTEGRITY_CODE', '', 'The code provides identification of the sender and a possibility of checking the data integrity. It\'s only disclosed to PayAnyWay system and registration system of the merchant', '6', '4', now())");
			$db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Transaction Mode', 'MODULE_PAYMENT_PAYANYWAY_TEST_MODE', 'Real', 'It indicates if the request is made in a test mode', '6', '5', 'zen_cfg_select_option(array(\'Real\', \'Test\'), ', now())");
			$db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Payment Zone', 'MODULE_PAYMENT_PAYANYWAY_ZONE', '0', 'If a zone is selected, only enable this payment method for that zone', '6', '6', 'zen_get_zone_class_title', 'zen_cfg_pull_down_zone_classes(', now())");

			$db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('PayAnyWay Login', 'MODULE_PAYMENT_PAYANYWAY_LOGIN', '', 'Login to PayAnyWay account', '6', '7', now())");
			$db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('PayAnyWay Password', 'MODULE_PAYMENT_PAYANYWAY_PASSWORD', '', 'Password to PayAnyWay account', '6', '8', now())");

			$db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Set Preparing Order Status', 'MODULE_PAYMENT_PAYANYWAY_PREPARE_ORDER_STATUS_ID', '0', 'Set the status of prepared orders made with this payment module to this value', '6', '7', 'zen_cfg_pull_down_order_statuses(', 'zen_get_order_status_name', now())");
			$db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Set Acknowledged Order Status', 'MODULE_PAYMENT_PAYANYWAY_ORDER_STATUS_ID', '0', 'Set the status of orders made with this payment module to this value', '6', '8', 'zen_cfg_pull_down_order_statuses(', 'zen_get_order_status_name', now())");
			$db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort order of display.', 'MODULE_PAYMENT_PAYANYWAY_SORT_ORDER', '0', 'Sort order of display. Lowest is displayed first', '6', '9', now())");
		}

		function remove() {
			global $db;
			$db->Execute("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
		}

		function keys() {
			return array('MODULE_PAYMENT_PAYANYWAY_STATUS', 'MODULE_PAYMENT_PAYANYWAY_LOGIN', 'MODULE_PAYMENT_PAYANYWAY_PASSWORD', 'MODULE_PAYMENT_PAYANYWAY_SERVER', 'MODULE_PAYMENT_PAYANYWAY_MERCHANT_ID', 'MODULE_PAYMENT_PAYANYWAY_CURRENCY_CODE', 'MODULE_PAYMENT_PAYANYWAY_DATA_INTEGRITY_CODE', 'MODULE_PAYMENT_PAYANYWAY_TEST_MODE', 'MODULE_PAYMENT_PAYANYWAY_ZONE', 'MODULE_PAYMENT_PAYANYWAY_PREPARE_ORDER_STATUS_ID', 'MODULE_PAYMENT_PAYANYWAY_ORDER_STATUS_ID', 'MODULE_PAYMENT_PAYANYWAY_SORT_ORDER');
		}
	}
?>