<?php
/*
	PayAnyWay payment module
*/
	require_once (dirname(__FILE__).'/payanyway.php');

	class payanyway_plastic extends payanyway{
		var $code, $title, $description, $enabled;
		var $params = array('unit_id' => 'card', 'limit_ids' => 'card', 'account_id' => '159', 'online' => 1);

		// class constructor
		function payanyway_plastic() {
			global $order;

			$this->code = 'payanyway_plastic';
			$this->title = MODULE_PAYMENT_PAYANYWAY_PLASTIC_TEXT_TITLE;
			$this->description = MODULE_PAYMENT_PAYANYWAY_PLASTIC_TEXT_DESCRIPTION;
			$this->sort_order = MODULE_PAYMENT_PAYANYWAY_PLASTIC_SORT_ORDER;
			$this->enabled = ((MODULE_PAYMENT_PAYANYWAY_PLASTIC_STATUS == 'True') ? true : false);

			if ((int)MODULE_PAYMENT_PAYANYWAY_PREPARE_ORDER_STATUS_ID > 0) {
				$this->order_status = MODULE_PAYMENT_PAYANYWAY_PREPARE_ORDER_STATUS_ID;
			}

			if (is_object($order)) $this->update_status();
		}

		// class methods
		function update_status() {
			global $order,$db;

			if ( ($this->enabled == true) && ((int)MODULE_PAYMENT_PAYANYWAY_PLASTIC_ZONE > 0) ) {
				$check_flag = false;
				$check_query = $db->Execute("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_PAYMENT_PAYANYWAY_PLASTIC_ZONE . "' and zone_country_id = '" . $order->billing['country']['id'] . "' order by zone_id");
				while ($check = $check_query->fields) {
					if ($check['zone_id'] < 1) {
						$check_flag = true;
						break;
					} elseif ($check['zone_id'] == $order->billing['zone_id']) {
						$check_flag = true;
						break;
					}
				}

				if ($check_flag == false) {
					$this->enabled = false;
				}
			}
		}

		function check() {
			global $db;
			if (!isset($this->_check)) {
				$check_query = $db->Execute("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_PAYANYWAY_PLASTIC_STATUS'");
				$this->_check = $check_query->RecordCount();
			}
			return $this->_check;
		}

		function install() {
			global $db;
			$check_query = $db->Execute("select orders_status_id from " . TABLE_ORDERS_STATUS . " where orders_status_name = 'Preparing [PayAnyWay]' limit 1");

			if ($check_query->RecordCount() < 1) {
				$status_query = $db->Execute("select max(orders_status_id) as status_id from " . TABLE_ORDERS_STATUS);
				$status = $status_query->fields;

				$status_id = $status['status_id']+1;

				$languages = zen_get_languages();

				for ($i=0, $n=sizeof($languages); $i<$n; $i++) {
					$db->Execute("insert into " . TABLE_ORDERS_STATUS . " (orders_status_id, language_id, orders_status_name) values ('" . $status_id . "', '" . $languages[$i]['id'] . "', 'Preparing [PayAnyWay]')");
				}

				$flags_query = $db->Execute("describe " . TABLE_ORDERS_STATUS . " public_flag");
				if ($flags_query->RecordCount() == 1) {
					$db->Execute("update " . TABLE_ORDERS_STATUS . " set public_flag = 1 and downloads_flag = 0 where orders_status_id = '" . $status_id . "'");
				}
			} else {
				$check = $check_query->fields;

				$status_id = $check['orders_status_id'];
			} 
		
			$db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable PayAnyWay Module', 'MODULE_PAYMENT_PAYANYWAY_PLASTIC_STATUS', 'True', 'Do you want to accept PayAnyWay payments?', '6', '1', 'zen_cfg_select_option(array(\'True\', \'False\'), ', now())");
			$db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Payment Zone', 'MODULE_PAYMENT_PAYANYWAY_PLASTIC_ZONE', '0', 'If a zone is selected, only enable this payment method for that zone', '6', '6', 'zen_get_zone_class_title', 'zen_cfg_pull_down_zone_classes(', now())");
			$db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort order of display.', 'MODULE_PAYMENT_PAYANYWAY_PLASTIC_SORT_ORDER', '0', 'Sort order of display. Lowest is displayed first', '6', '9', now())");
		}

		function remove() {
			global $db;
			$db->Execute("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
		}

		function keys() {
			return array('MODULE_PAYMENT_PAYANYWAY_PLASTIC_STATUS', 'MODULE_PAYMENT_PAYANYWAY_PLASTIC_ZONE', 'MODULE_PAYMENT_PAYANYWAY_PLASTIC_SORT_ORDER');
		}
	}
?>
