<?php
/*
	PayAnyWay payment module
*/
	require_once (dirname(__FILE__).'/payanyway.php');

	class payanyway_post extends payanyway{
		var $code, $title, $description, $enabled;
		var $params = array('unit_id' => 1029, 'limit_ids' => '1029', 'account_id' => '15', 'online' => 0);

		// class constructor
		function payanyway_post() {
			global $order;

			$this->code = 'payanyway_post';
			$this->title = MODULE_PAYMENT_PAYANYWAY_POST_TEXT_TITLE;
			$this->description = MODULE_PAYMENT_PAYANYWAY_POST_TEXT_DESCRIPTION;
			$this->sort_order = MODULE_PAYMENT_PAYANYWAY_POST_SORT_ORDER;
			$this->enabled = ((MODULE_PAYMENT_PAYANYWAY_POST_STATUS == 'True') ? true : false);

			if ((int)MODULE_PAYMENT_PAYANYWAY_PREPARE_ORDER_STATUS_ID > 0) {
				$this->order_status = MODULE_PAYMENT_PAYANYWAY_PREPARE_ORDER_STATUS_ID;
			}

			if (is_object($order)) $this->update_status();
		}

		// class methods
		function update_status() {
			global $order,$db;

			if ( ($this->enabled == true) && ((int)MODULE_PAYMENT_PAYANYWAY_POST_ZONE > 0) ) {
				$check_flag = false;
				$check_query = $db->Execute("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_PAYMENT_PAYANYWAY_POST_ZONE . "' and zone_country_id = '" . $order->billing['country']['id'] . "' order by zone_id");
				while ($check = $check_query->fields) {
					if ($check['zone_id'] < 1) {
						$check_flag = true;
						break;
					} elseif ($check['zone_id'] == $order->billing['zone_id']) {
						$check_flag = true;
						break;
					}
				}

				if ($check_flag == false) {
					$this->enabled = false;
				}
			}
		}

		function selection() {
		  $selection = array(
			'id' => $this->code,
			'module' => $this->title,
			'description'=>$this->info,
			'fields' => array(
						   array('title' => MODULE_PAYMENT_PAYANYWAY_POST_SENDERINDEX_TITLE,
								 'field' => zen_draw_input_field('payanyway_sender_index', $_SESSION['payanyway_sender_index'])),
						   array('title' => MODULE_PAYMENT_PAYANYWAY_POST_SENDERADDRESS_TITLE,
								 'field' => zen_draw_input_field('payanyway_sender_address', $_SESSION['payanyway_sender_address'])),
						   array('title' => MODULE_PAYMENT_PAYANYWAY_POST_SENDERNAME_TITLE,
								 'field' => zen_draw_input_field('payanyway_sender_name', $_SESSION['payanyway_sender_name']))
						   ));

			return $selection;
		}

		function pre_confirmation_check() {
			$this->payanyway_sender_index = zen_db_prepare_input($_POST['payanyway_sender_index']);
			$this->payanyway_sender_address = zen_db_prepare_input($_POST['payanyway_sender_address']);
			$this->payanyway_sender_name = zen_db_prepare_input($_POST['payanyway_sender_name']);
		}

		function process_button() {
		  $process_button_string  = zen_draw_hidden_field('payanyway_sender_index', $this->payanyway_sender_index);
		  $process_button_string .= zen_draw_hidden_field('payanyway_sender_address', $this->payanyway_sender_address);
		  $process_button_string .= zen_draw_hidden_field('payanyway_sender_name', $this->payanyway_sender_name);
		  return $process_button_string;
		}

		function before_process() {
			 $this->pre_confirmation_check();
			return false;
		}

		function after_process() {
			global $insert_id, $currencies, $order, $db;

			if ($this->order_status)
				vam_db_query("UPDATE ".TABLE_ORDERS." SET orders_status='".$this->order_status."' WHERE orders_id='".$insert_id."'");
			
			switch (MODULE_PAYMENT_PAYANYWAY_TEST_MODE) {
				case 'Real':
					$test_mode = '0';
					break;
				case 'Test':
					$test_mode = '1';
					break;
			}
			
			$lang_query = $db->Execute("select code from " . TABLE_LANGUAGES . " where languages_id = '" . (int)$languages_id . "'");
			$lang = $lang_query->fields; 
			
			switch (strtolower($lang['code'])) {
				case 'en':
				case 'ru':
					$language_code = strtolower($lang['code']);
					break;
				default:
					$language_code = strtolower(DEFAULT_LANGUAGE);
			}
			
//			$transactionId = STORE_NAME . date('Ymdhis') . rand (0, 99999);
			$amount = number_format($order->info['total'] * $currencies->get_value(MODULE_PAYMENT_PAYANYWAY_CURRENCY_CODE), 2, '.', '');
			$order_id = $insert_id;
			$currency = ('RUR' == MODULE_PAYMENT_PAYANYWAY_CURRENCY_CODE) ? 'RUB' : MODULE_PAYMENT_PAYANYWAY_CURRENCY_CODE;
			
			$_SESSION['cart']->reset(true);
			unset($_SESSION['sendto']);
			unset($_SESSION['billto']);
			unset($_SESSION['shipping']);
			unset($_SESSION['payment']);
			unset($_SESSION['comments']);
			unset($_SESSION['payanyway_sender_index']);
			unset($_SESSION['payanyway_sender_address']);
			unset($_SESSION['payanyway_sender_name']);
												
			zen_redirect( zen_href_link('payanyway_invoice') .
												'&MNT_ID=' . MODULE_PAYMENT_PAYANYWAY_MERCHANT_ID .
												'&MNT_TRANSACTION_ID=' . $order_id . 
												'&MNT_AMOUNT=' . $amount .
												'&MNT_CURRENCY_CODE=' . $currency .
												'&MNT_TEST_MODE=' . $test_mode .
												'&MNT_SIGNATURE=' . md5(MODULE_PAYMENT_PAYANYWAY_MERCHANT_ID . $order_id . $amount . $currency . $test_mode . MODULE_PAYMENT_PAYANYWAY_DATA_INTEGRITY_CODE) .
												'&MNT_SUCCESS_URL=' . zen_href_link(FILENAME_CHECKOUT_SUCCESS, '', 'SSL') .
												'&MNT_FAIL_URL=' . zen_href_link(FILENAME_CHECKOUT_PAYMENT, '', 'SSL') .
												'&paymentSystem.unitId=' . $this->params['unit_id'] .
												'&paymentSystem.limitIds=' . $this->params['limit_ids'] .
												'&paymentSystem.accountId=' . $this->params['account_id'] .
												'&additionalParameters.mailofrussiaSenderIndex=' . urlencode($this->payanyway_sender_index) .
												'&additionalParameters.mailofrussiaSenderAddress=' . urlencode($this->payanyway_sender_address) .
												'&additionalParameters.mailofrussiaSenderName=' . urlencode($this->payanyway_sender_name) .
												'&payment_system=' . $this->code .
												'&followup=true' .
												'&javascriptEnabled=true' .
												'&orderId=' . $order_id .
												'&customerId=' . $customer_id .
												'&moneta.locale=' . $language_code);
		}
		
		function check() {
			global $db;
			if (!isset($this->_check)) {
				$check_query = $db->Execute("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_PAYANYWAY_POST_STATUS'");
				$this->_check = $check_query->RecordCount();
			}
			return $this->_check;
		}

		function install() {
			global $db;
			$check_query = $db->Execute("select orders_status_id from " . TABLE_ORDERS_STATUS . " where orders_status_name = 'Preparing [PayAnyWay]' limit 1");

			if ($check_query->RecordCount() < 1) {
				$status_query = $db->Execute("select max(orders_status_id) as status_id from " . TABLE_ORDERS_STATUS);
				$status = $status_query->fields;

				$status_id = $status['status_id']+1;

				$languages = zen_get_languages();

				for ($i=0, $n=sizeof($languages); $i<$n; $i++) {
					$db->Execute("insert into " . TABLE_ORDERS_STATUS . " (orders_status_id, language_id, orders_status_name) values ('" . $status_id . "', '" . $languages[$i]['id'] . "', 'Preparing [PayAnyWay]')");
				}

				$flags_query = $db->Execute("describe " . TABLE_ORDERS_STATUS . " public_flag");
				if ($flags_query->RecordCount() == 1) {
					$db->Execute("update " . TABLE_ORDERS_STATUS . " set public_flag = 1 and downloads_flag = 0 where orders_status_id = '" . $status_id . "'");
				}
			} else {
				$check = $check_query->fields;

				$status_id = $check['orders_status_id'];
			} 
		
			$db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable PayAnyWay Module', 'MODULE_PAYMENT_PAYANYWAY_POST_STATUS', 'True', 'Do you want to accept PayAnyWay payments?', '6', '1', 'zen_cfg_select_option(array(\'True\', \'False\'), ', now())");
			$db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Payment Zone', 'MODULE_PAYMENT_PAYANYWAY_POST_ZONE', '0', 'If a zone is selected, only enable this payment method for that zone', '6', '6', 'zen_get_zone_class_title', 'zen_cfg_pull_down_zone_classes(', now())");
			$db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort order of display.', 'MODULE_PAYMENT_PAYANYWAY_POST_SORT_ORDER', '0', 'Sort order of display. Lowest is displayed first', '6', '9', now())");
		}

		function remove() {
			global $db;
			$db->Execute("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
		}

		function keys() {
			return array('MODULE_PAYMENT_PAYANYWAY_POST_STATUS', 'MODULE_PAYMENT_PAYANYWAY_POST_ZONE', 'MODULE_PAYMENT_PAYANYWAY_POST_SORT_ORDER');
		}
	}
?>
